<template>
  <div class="login-form">
    <div class="q-gutter-md">
      <q-input
        label="Email"
        v-model="form.fields.email"
        placeholder="john.doe@your-app.com"
        type="email"
        outlined
        bottom-slots
        v-bind="fieldHelpers.email.$attrs"
        v-on="fieldHelpers.email.$listeners"
      />
      <q-input
        label="Password"
        placeholder="Super secret password"
        type="password"
        outlined
        bottom-slots
        v-bind="fieldHelpers.password.$attrs"
        v-on="fieldHelpers.password.$listeners"
        v-model="form.fields.password"
      />
      <div class="text-center">
        <q-btn
          color="primary"
          label="Login"
          unelevated
          size="lg"
          style="width: 180px"
          @click="handleSubmit()"
          :loading="loading"
          :disable="loading || form.pristine"
        />
      </div>
      <div class="tip">Tip: random email, random password</div>
    </div>
  </div>
</template>

<script>
import { required, email } from 'vuelidate/lib/validators'
import { extractErrorObject } from 'src/utils/helpers'
import BaseFormMixin from 'src/mixins/BaseFormMixin'

const LOGIN_MODEL = {
  email: '',
  password: '',
}

export default {
  name: 'LoginForm',
  mixins: [BaseFormMixin],
  data: () => ({
    model: LOGIN_MODEL,
    loading: false,
  }),
  validations: {
    form: {
      fields: {
        email: { required, email },
        password: { required },
      },
    },
  },
  methods: {
    async submit() {
      const form = {
        email: this.form.fields.email.toLowerCase(),
        password: this.form.fields.password,
      }
      this.loading = true
      try {
        await this.$store.dispatch('auth/login', form)
      } catch (e) {
        const error = extractErrorObject(e)
        this.$q.notify({
          color: 'negative',
          textColor: 'white',
          icon: 'warning',
          message: `Login failed: ${error.status}: ${error.message}`,
          position: 'top',
        })
      } finally {
        this.loading = false
      }
    },
  },
}
</script>

<style lang="stylus" scoped>
.tip {
  margin-top: 36px;
  font-size: 12px;
  line-height: 14px;
  font-weight: 400;
  color: $secondary;
}
</style>
